"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.
"""

import nord.nord.Rule as Rule
from nord.athena.nodes.Location import get_position
import sys


class MoveLocation(Rule):
    """
    Since Move is an _operate_in_reverse edge, the target rule
    must behave as the source rule instead. So, it must populate
    the edge with the relevant cargo.
    """

    def apply(self):
        """Apply the rule to this end of the edge."""
        # set_position(self.node, self.edge.get_cargo())
        self.edge.set_cargo(get_position(self.node))
        return True


sys.modules[__name__] = MoveLocation
