"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
"""
import math


class Provider():
    cost = 0.0

    def __init__(self):
        self.cost_per_unit = self.cost
        self.address = None

    def amount(self, units):
        if math.isnan(units) or\
                math.isnan(self.cost_per_unit) or\
                math.isinf(units) or\
                math.isinf(self.cost_per_unit) or\
                self.address is None:
            return 0.0
        return self.cost_per_unit * units

    def set_cost(self, cost):
        if math.isnan(cost) or\
                math.isinf(cost):
            self.cost = 0.0
        else:
            self.cost_per_unit = cost

    def set_rx_address(self, address):
        self.address = address
