"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
"""
import nord.nord.Runtime as RT
import nord.nord.Map as Map
import nord.pasion.managers.sessionmanager as sm
import json


def test_cost_of_map():
    try:
        graph = json.load(open('tests/maps/helloworld.n', 'r'))
    except FileNotFoundError:
        graph = json.load(open('pasion/tests/maps/helloworld.n', 'r'))
    m1 = Map(graph)
    rt = RT.Runtime()
    sm.create_session('ThisGuy',
                      'SW_provider_addr',
                      'HW_provider_addr',
                      'Net_provider_addr',
                      'Stor_provider_addr')
    sm.get_current_session().add_credit(1000.0)
    assert sm.get_balance() == 1000.0
    m1.run(rt, [])
    bal = sm.get_balance()
    assert bal < 994.3
    assert bal > 994.23
