"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
"""
from nord.pasion.providers._base import Provider


def test_amount():
    p = Provider()
    p.set_rx_address('0xNOPE')
    assert p.amount(1.0) == 0.0


def test_set_cost():
    p = Provider()
    p.set_cost(2.0)
    p.set_rx_address('0xNOPE')
    assert p.amount(1.0) == 2.0


def test_set_address():
    p = Provider()
    p.set_cost(13.0)
    assert p.amount(22.0) == 0.0
    p.set_rx_address('0xNOPE')
    assert p.address == '0xNOPE'
    assert p.amount(2.0) == 26.0
