"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--

"""

_node_catalog = {}


def add_node(node):
    global _node_catalog
    for category in node.get_filter_categories():
        if category not in _node_catalog:
            _node_catalog[category] = list()
        if node not in _node_catalog[category]:
            _node_catalog[category].append(node)


def rem_node(node):
    global _node_catalog
    for category in node.get_filter_categories():
        if node in _node_catalog[category]:
            _node_catalog[category].remove(node)


def hide_category(category):
    global _node_catalog
    if category in _node_catalog:
        for node in _node_catalog[category]:
            node.hide()


def hide_not_category(category):
    global _node_catalog

    keepers = _node_catalog.get(category, [])
    for cat in _node_catalog:
        if not cat == category:
            for node in _node_catalog[cat]:
                if node not in keepers:
                    node.hide()


def show_category(category):
    global _node_catalog
    if category in _node_catalog:
        for node in _node_catalog[category]:
            node.show()


def show_not_category(category):
    global _node_catalog
    keepers = _node_catalog.get(category, [])
    for cat in _node_catalog:
        if not cat == category:
            for node in _node_catalog[cat]:
                if node not in keepers:
                    node.show()
