"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--

"""

from nord.sigurd.utils.verboser import funlog
from nord.sigurd.shell.model import Model

class Glyph(Model):
    def __init__(s, char, idx, text, app, visible=True):
        if visible:
            uid = "{}-{}-{}".format(text.uid, idx, char)
            super().__init__(uid, char, app, hoverable=False)
        s.visible = visible
        s.char = char


    def setTextIdx(s, pos):
        s.textPos = pos

    def getTextPos(s):
        if hasattr(s, 'textPos'):
            return s.textPos
        else:
            return -1

    @funlog
    def setTextParent(s, text):
        s.text = text

    @funlog
    def isDrawn(s):
        if hasattr(s, 'drawn'):
            return s.drawn
        else:
            return False

    @funlog
    def setDrawn(s):
        s.drawn = True

    @funlog
    def unsetDrawn(s):
        s.drawn = False

    @funlog
    def handle_clicked(s, *args, **kwargs):
        if hasattr(s, 'text'):
            s.text.handle_clicked(*args, **kwargs)
