"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--

"""

import random
import uuid

__n1__ = [
      'Red'
    , 'Viscious'
    , 'Cuddly'
    , 'Prime'
    , 'Super'
    , 'Under'
    , 'Green'
    , 'Fat'
    , 'Crude'
    , 'Hangry'
    , 'Light'
    , 'Small'
    , 'Hot'
    , 'Cool'
    , 'Smart'
    , 'Extra'
    , 'Aloof'
    , 'Distant'
    , 'Hard'
    , 'Sensitive'
    , 'Friendly'
    , 'Mega'
    , 'Gothic'
    , 'Damp'
    , 'Soggy'
    , 'Split'
    , 'Arrid'
    , 'Sharp'
    , 'Flat'
    , 'Round'
    , 'Windy'
    , 'Mild'
]

__n2__ = [
      'Orbital'
    , 'Atomic'
    , 'Murderous'
    , 'Mischevious'
    , 'Artsy'
    , 'Molecular'
    , 'Ranged'
    , 'Tuned'
    , 'Vehicular'
    , 'Nordic'
    , 'Elevated'
    , 'Sublimated'
    , 'Cutaneous'
    , 'Dental'
    , 'Sanded'
    , 'Blasted'
    , 'Aerated'
    , 'Painted'
    , 'Polished'
    , 'Rounded'
    , 'Squished'
    , 'Oderous'
    , 'Chipped'
    , 'Pounded'
    , 'Garnished'
    , 'Forked'
    , 'Flooded'
    , 'Scientific'
    , 'Culinary'
    , 'Onerous'
    , 'Bifurcated'
    , 'Bioactive'
    , 'Viscous'
]

__n3__ = [
      'Bird'
    , 'Sparrow'
    , 'Lizard'
    , 'Table'
    , 'Megan'
    , 'Sue'
    , 'Building'
    , 'Aardvark'
    , 'Cheese'
    , 'Plate'
    , 'Meatpie'
    , 'Magpie'
    , 'Scottsman'
    , 'Mountain'
    , 'Cloud'
    , 'Cave'
    , 'Giant'
    , 'Boulder'
    , 'Catapult'
    , 'Siege'
    , 'Sword'
    , 'Rampart'
    , 'Pangolin'
    , 'Iceberg'
    , 'Ship'
    , 'War'
    , 'Laser'
    , 'Presentation'
    , 'Politician'
    , 'Hair'
    , 'Bag'
    , 'Turnip'
    , 'Dog'
    , 'Slobber'
    , 'Ceiling'
    , 'Curtain'
    , 'Wall'
    , 'Bouy'
    , 'Wave'
    , 'Sound'
    , 'Amplifier'
    , 'Sausage'
]

_combos = []
_genCount = 0

def _regenCombos():
    global _genCount
    global _combos
    for n1 in __n1__:
        for n2 in __n2__:
            for n3 in __n3__:
                if _genCount is 0:
                    _combos.append("{} {} {}".format(n1, n2, n3))
                else:
                    _combos.append("{} {} {}{}".format(n1, n2, n3, _genCount))
    _genCount+=1

def get(obj=None):
    global _combos
    if len(_combos) < 1:
        _regenCombos()

    pfx = ""
    if obj is not None:
        pfx = obj.__class__.__name__ + "-"
    idx = int(random.random() * len(_combos))
    return pfx + _combos.pop(idx)

def id():
    return str(uuid.uuid4())
