"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--

"""

from nord.sigurd.utils.verboser import funlog
from nord.sigurd.utils.log import *
from nord.sigurd.shell.labeledmodel import LabeledModel
from nord.sigurd.shell.modelmenu import ModelMenu
from nord.sigurd.shell.menuItem import MenuItem
import nord.sigurd.managers.statemanager as em
import nord.sigurd.managers.event as event

class Action(LabeledModel):
    def __init__(s, uid, app):
        super().__init__(uid, 'action', app)
        s.menu = ModelMenu()

        @event.callback
        @funlog
        def callback(*args, **kwargs):
            warn("==== Calling Action Selected Callback")
            em.model_toggle_selected(s)
        s.menu.add_item(MenuItem('menudefselect', callback))

        @event.callback
        @funlog
        def callback2(*args, **kwargs):
            warn("==== Calling Action Start Connection Callback")
            em.model_start_connection(s, 'def')
        s.menu.add_item(MenuItem('menudefconnect', callback2))

        @event.callback
        @funlog
        def callback3(*args, **kwargs):
            warn("==== Calling Action Something Else Callback")
            em.model_edit_name(s, 'def')
        s.menu.add_item(MenuItem('textmenuicon', callback3))

    @funlog
    def handle_clicked(s, *args, **kwargs):
        #em.postPending('hide_model_menu', s.menu)
        em.post_pending('model_toggle_selected', s)
        em.data_show_menu(s)
