"""
Copyright 2020 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
"""
import pytest
import nord.sigurd.shell.vismap as vm
import nord.sigurd.managers.objectmanager as om
import nord.sigurd.managers.containermanager as cm
from pathlib import Path


# @pytest.mark.xfail  # When run with all other tests, getTightBounds returns None...
@pytest.mark.panda3d()
def test_load_render_in_container(init_panda3d):
    app = init_panda3d
    if Path('./sigurd/tests/maps/render_in_container_tst.n').exists():
        app.load_map('./sigurd/tests/maps/render_in_container_tst.n')
    elif Path('./tests/maps/render_in_container_tst.n').exists():
        app.load_map('./tests/maps/render_in_container_tst.n')
    else:
        raise Exception("Cannot find test map to load")
    karte = vm.get_working_map()

    contained_data = karte.nodes['df06905b-e28a-414f-ab83-5fb4aabf92b9']
    container = karte.nodes['03d39100-e45a-4932-abe1-1019662c1087']
    vis_cd = om.fetch(contained_data.id)
    # vis_ctr = om.fetch(container.id)
    # Get the top level node (the render node so to speak)
    # of the embedded container
    ctr_render = cm.get_by_name(container.id)
    # Ensure that the data node is contained in the
    # embedded container's node path
    assert contained_data.visualization.data.get_parent().get_name() == ctr_render.get_name()
    # And, ensure that the top level node path, does
    # not have the contained data node
    assert len(render.findAllMatches(contained_data.id)) == 0  # noqa: F821
    # while True:
    #     app.one_loop_iteration()
