"""
Copyright 2020 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
"""
import pytest
import nord.sigurd.managers.statemanager as em
from panda3d.core import Point3


@pytest.mark.panda3d()
def test_main_menu_visible(init_panda3d):
    """
    Assuming default statemanager and event maps
    a click on the empty screen should cause the
    mainmenu data attribute (nodepath) to become
    "visible". Another click off the menu, should cause
    the menu to be hidden again.
    """
    import nord.sigurd.shell.mainmenu as main
    assert main.data.is_hidden()
    em.mouse_freespace_click(Point3(0.0, 0.0, 0.0), init_panda3d)
    assert main.data.is_hidden() is False
    em.mouse_freespace_click(Point3(3.0, 8.0, 0.0), init_panda3d)
    assert main.data.is_hidden()
