"""
Copyright 2021 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
"""
import pytest
from panda3d.core import Point3
import nord.sigurd.shell.vismap as vm
from nord.wrigan.visibles.utils import dim_map, undim_map
import nord.sigurd.managers.objectmanager as om
import nord.sigurd.managers.containermanager as cm


def test_delegate_contents(init_panda3d):
    """
    Need to test:
    adding eligible_for("pass") nodes creates delegates
    removing same nodes removes delegates
    adding not eligible_for("pass") nodes does not create any delegates
    removing  not eligible_for("pass") nodes does not remove any delegates
    """
    app = init_panda3d
    container = vm.create_node("Container", Point3(0.0, 0.0, 0.0), space="nord")
    karte = vm.get_working_map()
    karte.connect_cdc_loopback() # So that delete will remove the node from the graph
    cm.enter(container.id)
    innerc = vm.create_node("Comment", Point3(1.0, 0.0, 0.0), space="nord")
    data = vm.create_node("Data", Point3(-1.0, 0.0, 0.0), space="nord")
    cm.exit()
    cm.enter(container.id)
    cm.exit()
    cm.enter(container.id)
    cm.exit()
    assert len(container.visualization.delegates['as_tgt']['pass']) == 1
    for did in container.visualization.decorationmanager.decorations.keys():
        nf = True
        for itm in container.visualization.delegates['as_tgt']['pass']:
            if itm.uid.startswith(did):
                nf = False
        assert not nf
    data.delete()
    karte.ship_changes()
    cm.enter(container.id)
    cm.exit()
    assert len(container.visualization.delegates) == 0
    for did in container.visualization.decorationmanager.decorations.keys():
        nf = True
        for itm in container.visualization.delegates['as_tgt']['pass']:
            if itm.uid.startswith(did):
                nf = False
        assert nf
    # while True:
    #     app.one_loop_iteration()
