"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--

"""

import nord.nord.nodes.Static as _Static


class Static(_Static):
    def __init__(self, graph, name, ntype):

        #
        #  THE NAME HANDLING NEEDS TO BE FIGURED OUT.
        #  CURRENTLY, A UUID IS GENERATED BY nord.nodes.Static
        #  This appears in the dataobject menu.
        # We need something a little more graceful...

        # stores the passed type in the _type member
        super().__init__(graph, name, ntype, None)

    def get(s):
        """
        Get the value from this data node

        Perhaps the type casting should be moved into Sushrut _static.py?
        """
        val = s.get_property('value')
        if s._type is not None and val is not None:
            return s._type(val)
        else:
            return val
