"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
Facilitate Containing this type of static data.
"""


import nord.nord.rules.AssignData as AssignData
import nord.sushrut.nodes.Dataobject as Dataobject
import nord.nord.nodes.Container as Container
import sys


class ContainsDatafunction(AssignData):  # pragma: no cover
    """The ContainsDatafunction rule allows the related target in the container."""
    def apply(self):
        # only set target value (via inherited method)
        # if the containing entity is a dataobject.
        source = self.edge.get_source()
        if isinstance(source, Dataobject):
            return super().apply()
        elif isinstance(source, Container):
            return True
        return False

    # def apply(self):
    # return super().apply()

    # def apply(self):
    #     """Implement the apply method."""
    #     tgt = self.edge.get_target()
    #     if not hasattr(tgt, 'value'):
    #         """
    #         It seems that the target does not have
    #         the containing object's method as its value....

    #         PERHAPS this is the appropriate place to ensure it
    #         is assigned?
    #         """
    #         parent_obj = self.edge.get_cargo()
    #         if not hasattr(tgt, 'name') and hasattr(tgt, '_sushrut_dataobject_keyname'):
    #             attrname = tgt._sushrut_dataobject_keyname
    #         elif hasattr(tgt, 'name'):
    #             attrname = tgt.name
    #         else:
    #             raise Exception("CRAP IMPLEMENTATION -- Contained Datafunction has no apparent method name")
    #         func_def = getattr(parent_obj.get(), attrname)
    #         tgt.set(func_def)
    #     pass


sys.modules[__name__] = ContainsDatafunction
