"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
Enable assignment to so named nodes.
"""

import nord.nord.rules.DataPass as DataPass
from nord.nord.exceptions import RuntimeException as RuntimeException
import sys


class DataarrayPass(DataPass):
    """Pass the list within the dataarray if available."""

    def apply(self):
        """Grab the value and pass as cargo if possible."""
        if hasattr(self.edge, 'delegate'):
            self.edge.apply_delegate(self)
            return True
        else:
            if hasattr(self.edge.get_source(), '_list'):
                self.edge.set_cargo(self.edge.get_source()._list)
                return True
            else:
                raise RuntimeException(_("Dataarray asked to pass, "  # noqa: F821
                                         "but has nothing to pass: {}").format(self.edge.get_source()))


sys.modules[__name__] = DataarrayPass
