"""
Copyright 2019 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--
Enable assignment to so named nodes.
"""

import nord.nord.rules.DataAssign as DataAssign
import sys


class DatafunctionAssign(DataAssign):
    """DatafunctionAssign sets the cargo of the edge based upon its value."""

    def apply(self):
        cargo = None
        if not self.node.has_executed() or self.node.get_unfollowed_sources():
            return False
        if hasattr(self.node, '_sushrut_datafunction_returnvalue'):
            cargo = self.node._sushrut_datafunction_returnvalue
        else:
            cargo = self.node.value
        self.edge.set_cargo(cargo)
        return True


sys.modules[__name__] = DatafunctionAssign
