"""
Copyright 2021 NoRD Software Foundation

This file is part of NoRD.

NoRD is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

NoRD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with NoRD.  If not, see <https://www.gnu.org/licenses/>.

--

"""
import pytest
import nord.sushrut.nodes.Datavoid as Datavoid
from pathlib import Path
from nord.nord.Runtime import Runtime
import nord.nord.Map as Map
import nord.sigurd.shell.vismap as vm
import nord.sigurd.managers.containermanager as cm
import nord.sigurd.managers.objectmanager as om
from panda3d.core import Point3


def test_datavoid_has_correct_edge_menu(init_panda3d):
    """
    This test catches if the rules are not listed in the nord.sushrut.rules.__init__.py __all__ array
    """
    app = init_panda3d
    mappath = '/test/maps/test_datavoid.n'
    if Path(f'./sushrut').exists():
        app.load_map(f'./sushrut/{mappath}')
    elif Path(mappath).exists():
        app.load_map(mappath)
    else:
        raise Exception("Cannot find test map to load")
    karte = vm.get_working_map()
    void = om.fetch("1356e0ef-32f2-4c3a-be87-6e3931d0a954")
    assignitmpres = False
    passitmpres = False
    flowitmpres = False
    for itm in void.connMenu.submenu.items:
        if itm.modelname.endswith('datavoidassign'):
            assignitmpres = True
        if itm.modelname.endswith('datavoidpass'):
            passitmpres = True
        if itm.modelname.endswith('menuflow'):
            flowitmpres = True
    assert assignitmpres
    assert passitmpres
    assert flowitmpres
    # while True:
    #     app.one_loop_iteration()
